const { GObject, St, Gio, GLib } = imports.gi;
const PanelMenu = imports.ui.panelMenu;
const PopupMenu = imports.ui.popupMenu;
const Util = imports.misc.util;
const Volume = imports.ui.status.volume;
let control = Volume.getMixerControl();
let output = control.get_default_sink();
let BOOSTED = false;

var VolumeBooster = GObject.registerClass(
  {
    GTypeName: "VolumeBooster",
    Name: "VolumeBooster",
  },
  class VolumeBooster extends PanelMenu.Button {
    _init() {
      super._init(1, "VolumeBooster", false);

      let box = new St.BoxLayout({ style_class: "panel-status-menu-box" });

      this.icon = new St.Icon({
        icon_name: "emblem-music-symbolic",
        style_class: "custom-icon",
      });
      box.add(this.icon);
      this.actor.add_child(box);
      this._buildMenu();
    }

    _destroy() {
      output = control.get_default_sink();
      output.volume = control.get_vol_max_norm();
      output.push_volume();
      this.destroy();
    }

    _buildMenu() {
      let that = this;

      that.customMenuItem = new PopupMenu.PopupSwitchMenuItem(
        _("Boost Volume (x2) "),
        BOOSTED,
        { reactive: true }
      );

      that.customMenuItem.connect("toggled", that._onToggle.bind(that));

      that.menu.addMenuItem(that.customMenuItem);
    }

    _onToggle() {
      output = control.get_default_sink();
      BOOSTED = this.customMenuItem.state;

      if (!BOOSTED) {
        output.volume = control.get_vol_max_norm();
        output.push_volume();
        this.icon.remove_style_class_name("boosted");
      } else {
        output.volume = control.get_vol_max_amplified() * 2;
        output.change_is_muted(false);
        output.push_volume();
        this.icon.add_style_class_name("boosted");
      }
    }
  }
);
